# the _labscript suite_

### Experiment control and automation system

___

The _labscript suite_ is a powerful and extensible framework for experiment [composition](https://github.com/labscript-suite/labscript), [control](https://github.com/labscript-suite/runmanager), [execution](https://github.com/labscript-suite/blacs), and [analysis](https://github.com/labscript-suite/lyse). Developed for quantum science and quantum engineering; deployable in laboratory and in-field devices. Also applicable to optics, microscopy, materials engineering, biophysics, and any application predicated on the repetition of parameterised, hardware-timed experiments.


## Features

* Flexible and automated oversight of heterogeneous hardware.
* The most mature and widely used open-source control system in quantum science.
* Multiple analysis-based feedback modes.
* Extensible plugin architecture (e.g. machine learning online optimisation).
* Readily integrates with other software, including image acquisition, analysis, and even other control systems.
* Compose experiments as human-readable Python code, leveraging modularity, revision control and re-use.
* Dynamic visualisation of experiment composition and results.
* Remote operation: different modules can run on physically separate hosts / single modules can be run on multiple hosts (including hardware supervisor, [blacs](https://github.com/labscript-suite/blacs)).
* Auto-generating user-interfaces.
* High-level scripting: user-interface interaction can be programatically synthesised.


## Citing the _labscript suite_

If you use the _labscript suite_ to control your experiment or perform analysis, please cite one or more of the following publications:
